// TCONN_MFC_C++Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TCONN_MFC_C++.h"
#include "TCONN_MFC_C++Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTCONN_MFC_CDlg dialog



CTCONN_MFC_CDlg::CTCONN_MFC_CDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTCONN_MFC_CDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTCONN_MFC_CDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TCONNECTOR23, TC2);
	DDX_Control(pDX, IDC_EDIT2, edSettings);
	DDX_Control(pDX, IDC_EDIT3, edDataIn);
	DDX_Control(pDX, IDC_EDIT4, edWriteData);
	DDX_Control(pDX, IDC_LIST1, m_lbRxData);
	DDX_Control(pDX, IDC_CHK_ONDATA, m_chkOnDataEnable);
	DDX_Control(pDX, IDC_READ, m_btnRead);
	DDX_Control(pDX, IDC_BTN_WRITE, m_btnWrite);
}

BEGIN_MESSAGE_MAP(CTCONN_MFC_CDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_TCPROPDLG, OnBnClickedBtnTcpropdlg)
	ON_BN_CLICKED(IDC_READ, OnBnClickedRead)
	ON_BN_CLICKED(IDC_BTN_WRITE, OnBnClickedBtnWrite)
	ON_BN_CLICKED(IDC_CHK_ONDATA, OnBnClickedChkOndata)
END_MESSAGE_MAP()


// CTCONN_MFC_CDlg message handlers

BOOL CTCONN_MFC_CDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	this->edSettings.SetWindowText(this->FormatSettings(&TC2));
	this->edWriteData.SetWindowText("Enter your data here...");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTCONN_MFC_CDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTCONN_MFC_CDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTCONN_MFC_CDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
BEGIN_EVENTSINK_MAP(CTCONN_MFC_CDlg, CDialog)
	ON_EVENT(CTCONN_MFC_CDlg, IDC_TCONNECTOR23, 1, OnDataTconnector2, VTS_BSTR)
END_EVENTSINK_MAP()


CString CTCONN_MFC_CDlg::FormatSettings(CTConnector2* pTC)
{
	CString	sSet = "";
	if(pTC->get_IOType() == CTConnector2::eCOM)
	{
		sSet+= "Serial - ";
		sSet = pTC->get_Device() + ", ";
		sSet+= pTC->get_Baud()   + ", ";
		sSet+= pTC->get_Parity() + ", ";
		sSet+= pTC->get_Stop();
	}
	else if(pTC->get_IOType() == CTConnector2::eTCP)
	{
		sSet+= "TCP/IP - ";
		sSet+= pTC->get_Host() + " : ";
		sSet+= pTC->get_Service();
	}
	else if(pTC->get_IOType() == CTConnector2::eFILE)
	{
		sSet+= "File - ";
		sSet+= pTC->get_Device();
	}
	else if(pTC->get_IOType() == CTConnector2::eLPT)
	{
		sSet+= "Parallel port - ";
		sSet+= pTC->get_Device();
	}

	return sSet;
}

void CTCONN_MFC_CDlg::OnBnClickedBtnSettings()
{
	// TODO: Add your control notification handler code here
	edSettings.SetWindowText(FormatSettings(&TC2));
}

void CTCONN_MFC_CDlg::OnBnClickedBtnTcpropdlg()
{
	// TODO: Add your control notification handler code here
		TC2.PropertyDialog();
	edSettings.SetWindowText(FormatSettings(&TC2));

}

void CTCONN_MFC_CDlg::OnBnClickedRead()
{
	// TODO: Add your control notification handler code here
	CString sStatus;

	try
	{
		// open connection
		TC2.Open();
		
		// switch on wait cursor
		CWaitCursor hr;
		edDataIn.SetWindowText("Now waiting for data...");
		edDataIn.RedrawWindow();

		// try to read 20 Bytes within 5 seconds
		CString sData = TC2.Read(20, 5000);  

		// if something was received, display it
		if (TC2.GetNoOfBytesRead()>0)
			edDataIn.SetWindowText(sData);
	}
	catch (COleDispatchException * e)
	{
		// if our timeout period was reached without data,
		// or if the port is not accessible we get an exception
		
		if (HRESULT_CODE(e->m_scError) == ERROR_TIMEOUT)
			MessageBox("No data received during timeout period (5 seconds)!");
		else if (HRESULT_CODE(e->m_scError) == ERROR_FILE_NOT_FOUND)
			MessageBox("Device/Port not found!");
		else
			MessageBox(TC2.TranslateErrorNo(e->m_scError));
		
		edDataIn.SetWindowText("");
	}
	
	// close connection always - also in case of errors
	TC2.Close(); 
}

void CTCONN_MFC_CDlg::OnBnClickedBtnWrite()
{
	// TODO: Add your control notification handler code here

	try
	{
		// open connection
		TC2.Open();

		// retrieve data string from edit window
		CString sData;
		int nLen = edWriteData.GetWindowTextLength()+1;
		edWriteData.GetWindowText(sData.GetBuffer(nLen), nLen);
		sData.ReleaseBuffer();

		// switch on wait cursor
		CWaitCursor hr;

		// now write to port (device)
		int nCount = TC2.Write(sData.GetLength(), 5000, sData);

		// display how many bytes were written during timeout of 5 seconds
		CString sMsg;
		sMsg.Format("%d Bytes written.", nCount);
        MessageBox(sMsg);
	}
	catch (COleDispatchException * e)
	{
		if (HRESULT_CODE(e->m_scError) == ERROR_TIMEOUT)
			MessageBox("No data could be written during timeout period (5 seconds)!");
		else if (HRESULT_CODE(e->m_scError) == ERROR_FILE_NOT_FOUND)
			MessageBox("Device/Port not found!");
		else
			MessageBox(TC2.TranslateErrorNo(e->m_scError));
		edDataIn.SetWindowText("");
	}
	TC2.Close(); // close connection always - also in case of errors
}

void CTCONN_MFC_CDlg::OnDataTconnector2(LPCTSTR Data)
{
	// TODO: Add your message handler code here

	m_lbRxData.InsertString(-1, Data);

	// Select the last item in the list box.
	int nCount = m_lbRxData.GetCount();
	if (nCount > 0)
		m_lbRxData.SetCurSel(nCount-1);

}

void CTCONN_MFC_CDlg::OnBnClickedChkOndata()
{
	// TODO: Add your control notification handler code here
	try
	{
		if (m_chkOnDataEnable.GetCheck())
		{
			this->m_lbRxData.ResetContent();// clear list box entries

			TC2.put_Timeout(500);			// we set a timeout period of 0.5 sec for one event
			TC2.put_Timeout_Infinite(FALSE);// we want to use the timeout period for data packaging
			TC2.put_NoOfBytes(100);         // we want to get max 100 Bytes within one event

			TC2.Open();                     // open the port
			TC2.StartListen();				// start async mode (activate OnData event)
			
			this->m_lbRxData.AddString("Waiting for data...");
			m_btnRead.EnableWindow(FALSE);	// don't call the synchronous read during StartListen is active !
			m_btnWrite.EnableWindow(FALSE);
		}
		else
		{
			TC2.StopListen();
			TC2.Close();
			
			this->m_lbRxData.InsertString(-1, "Stopped!");
			m_btnRead.EnableWindow();
			m_btnWrite.EnableWindow();
		}
	}
	catch (COleDispatchException * e)
	{
		MessageBox(TC2.TranslateErrorNo(e->m_scError));
	}
}
